<!doctype html>
<!-- Note that adding an appcache really speeds things up after the first load
    You need to amend the appcache file to meet your needs.
    Don't forget to change the appcache file if you update ANY
    of the files in it otherwise the old versions will ALWAYS be used.
<html lang="en" manifest="./uibuilder.appcache">
-->
<html lang="en">
<!--
    This is the default, template html for uibuilder.
    It is meant to demonstrate the use of VueJS & bootstrap-vue to dynamically
    update the ui based on incoming/outgoing messages from/to the
    Node-RED server.

    You will want to alter this to suite your own needs. To do so,
    copy this file to <userDir>/uibuilder/<url>/src.
-->
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>VizBlock Controller</title>
    <meta name="description" content="VizBlock Controller - control your VizBlock">

    <link rel="icon" href="./images/node-blue.ico">

    <!-- See https://goo.gl/OOhYW5 -->
    <link rel="manifest" href="./manifest.json">
    <meta name="theme-color" content="#3f51b5">

    <!-- Used if adding to homescreen for Chrome on Android. Fallback for manifest.json -->
    <meta name="mobile-web-app-capable" content="yes">
    <meta name="application-name" content="VizBlock Controller">

    <!-- Used if adding to homescreen for Safari on iOS -->
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
    <meta name="apple-mobile-web-app-title" content="VizBlock Controller">

    <!-- Homescreen icons for Apple mobile use if required
        <link rel="apple-touch-icon" href="./images/manifest/icon-48x48.png">
        <link rel="apple-touch-icon" sizes="72x72" href="./images/manifest/icon-72x72.png">
        <link rel="apple-touch-icon" sizes="96x96" href="./images/manifest/icon-96x96.png">
        <link rel="apple-touch-icon" sizes="144x144" href="./images/manifest/icon-144x144.png">
        <link rel="apple-touch-icon" sizes="192x192" href="./images/manifest/icon-192x192.png">
    -->

    <link type="text/css" rel="stylesheet" href="../uibuilder/vendor/bootstrap/dist/css/bootstrap.min.css" />
    <link type="text/css" rel="stylesheet" href="../uibuilder/vendor/bootstrap-vue/dist/bootstrap-vue.css" />
    
    <link rel="stylesheet" href="./index.css" media="all">
</head>
<body>
    <div id="app" v-cloak>
        <b-container id="app_container">
            <h1>
                VizBlock Controller
            </h1>
            <h2>Simple input using Vue</h2>
            <b-form class="border p-3 m-2">
                <p>
                    You can very simply create a form using Vue & bootstrap-vue.
                    The form sends data back to Node-RED.
                    Look at the <code>increment</code> method in <code>index.js</code> to see how easy this is.
                </p>
                <p>
                    <b-form-input v-model="inputText" type="text" placeholder="Enter some text to send to Node-RED"></b-form-input><br>
                    <b-form-checkbox v-model="inputChkBox">
                        To tick or not to tick? That is the question
                    </b-form-checkbox><br>
                    <b-button id="btn_increment" pill variant="primary" v-on:click="increment">Increment</b-button>
                        &nbsp;&nbsp;Click Counter: <b>{{counterBtn}}</b>.
                    <p>Click on the button to increment the counter. It sends the data dynamically back to Node-RED as well.</p>
                </p>
            </b-form>

            <h2>Dynamic Data</h2>
            <p>Uses Vue to dynamically update in response to messages from Node-RED.</p>
            <p>
                Check out the <code>mounted</code> function in <code>index.js</code> to See
                how easy it is to update Vue data from Node-RED.
            </p>

            <b-card class="mt-3" header="Status" border-variant="info" header-bg-variant="info" header-text-variant="white" align="center" >
                <p class="float-left">Socket.io Connection Status: <b>{{socketConnectedState}}</b></p>
                <p class="float-right">Time offset between browser and server: <b>{{serverTimeOffset}}</b> hours</p>
            </b-card>

            <b-card class="mt-3" header="Normal Messages" border-variant="primary" header-bg-variant="primary" header-text-variant="white" align="left" >
                <p>
                    Messages: Received=<b>{{msgsReceived}}</b>, Sent=<b>{{msgsSent}}</b>
                </p>
                <pre v-html="hLastRcvd" class="syntax-highlight"></pre>
                <pre v-html="hLastSent" class="syntax-highlight"></pre>
                <p slot="footer" class="mb-0">
                    The received message is from the input to the uibuilder node.
                    The send message will appear out of port #1 of the node.
                </p>
            </b-card>

            <b-card class="mt-3" header="Control Messages" border-variant="secondary" header-bg-variant="secondary" header-text-variant="white" align="left" >
                <p>
                    Control Messages: Received=<b>{{msgsControl}}</b>, Sent=<b>{{msgsCtrlSent}}</b>
                </p>
                <pre v-html="hLastCtrlRcvd" class="syntax-highlight"></pre>
                <pre v-html="hLastCtrlSent" class="syntax-highlight"></pre>
                <p slot="footer" class="mb-0">
                    Control messages always appear out of port #2 of the uibuilder node
                    whether they are from the server or the client. The <code>from</code> property
                    of the message tells you where it came from.
                </p>
            </b-card>

        </b-container>
    </div>

    <!-- These MUST be in the right order. Note no leading / -->
    <!-- REQUIRED: Socket.IO is loaded only once for all instances
                     Without this, you don't get a websocket connection -->
    <script src="../uibuilder/vendor/socket.io/socket.io.js"></script>

    <!-- --- Vendor Libraries - Load in the right order --- -->
    <script src="../uibuilder/vendor/vue/dist/vue.js"></script> <!-- dev version with component compiler -->
    <!-- <script src="../uibuilder/vendor/vue/dist/vue.min.js"></script>   prod version with component compiler -->
    <!-- <script src="../uibuilder/vendor/vue/dist/vue.runtime.min.js"></script>   prod version without component compiler -->
    <script src="../uibuilder/vendor/bootstrap-vue/dist/bootstrap-vue.js"></script>

    <!-- REQUIRED: Sets up Socket listeners and the msg object -->
    <!-- <script src="./uibuilderfe.js"></script>   //dev version -->
    <script src="./uibuilderfe.min.js"></script> <!--    //prod version -->
    <!-- OPTIONAL: You probably want this. Put your custom code here -->
    <script src="./index.js"></script>

</body>

</html>